/***************************************************************************
                          bioclient.cpp  -  description
                             -------------------
    begin                : Mon Jan 21 12:38:33 CET 2002
    copyright            : (C) 2002 by Willem Froehling
    email                : willem@koram.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "bioclient.h"
#include <iostream.h>

BioClient::BioClient(const QString& host, Q_UINT16 port)
{
        hostname = host;
        portnum = port;

        pm = NULL;


        // GUI layout
        setSpacing(10);
        QString itext = QString(
                                "Authentikations Client\n"
                                "----------------------\n"
                                "W. Froehling 2003"

                        );
        QLabel *lb = new QLabel( itext, this );
        lb->setAlignment( AlignHCenter );

        infoText = new QMultiLineEdit( this );
        infoText->setReadOnly(TRUE);
        infoText->setMinimumSize(200,500);
        infoText->setFont(QFont("helvetica",10, QFont::Bold));

        QVBox *prozessLayoutBox = new QVBox(this);
        prozessLayoutBox->setSpacing(10);

        QGroupBox *methodsBox = new QGroupBox(2, QGroupBox::Vertical, "Benutzer und Role:",prozessLayoutBox);

        QHBox *hb1 = new QHBox(methodsBox);
        (void)new QLabel("Name : ",hb1);
        authTextOne = new QLineEdit( "P_Mustermann", hb1 );
        authTextOne->setSelection(0,authTextOne->cursorPosition());


        QHBox *hb2 = new QHBox(methodsBox);
        (void)new QLabel("Role : ",hb2);
        authTextTwo = new QLineEdit( "simpleUser", hb2 );
        authTextTwo->setSelection(0,authTextTwo->cursorPosition());

        /* Step-By-Step GUI */
        QGroupBox* debugBox = new QGroupBox(2, QGroupBox::Horizontal, "Debug",prozessLayoutBox);
        QHBox *hb3 = new QHBox(debugBox);
        SbSCheckBox = new QCheckBox("Step-By-Step  ", hb3);

        step = new QPushButton(tr("Nchster Schritt"), hb3);
        step->setEnabled(FALSE);

        QPushButton *send = new QPushButton(tr("Authentikation") , prozessLayoutBox);

        QHBox *connectionButtons = new QHBox(this);
        connectionButtons->setSpacing(10);
        QPushButton *connectB = new QPushButton(tr("Verbinde mit Server"), connectionButtons);
        QPushButton *closeB = new QPushButton(tr("Verbindung abbrechen") , connectionButtons);

        QPushButton *quit = new QPushButton(tr("Quit") , this);

        connect( send, SIGNAL(clicked()), SLOT(sendToServer()) );
        connect(connectB, SIGNAL(clicked()), SLOT(startConnection()) );
        connect( closeB, SIGNAL(clicked()), SLOT(closeConnection()) );
        connect( quit, SIGNAL(clicked()), qApp, SLOT(quit()) );
        connect( step, SIGNAL(clicked()), SLOT(sbsPressed()) );
}

BioClient::~BioClient()
{}


void BioClient::startConnection()
{
        if (pm == NULL) {
                pm = new ProtocolManager(hostname, portnum, this);

                connect( pm, SIGNAL(displayDataPM(QString)), SLOT(displayDataBC(QString)) );
        }

        pm->startConnection();
        /* Gibt den Objectbaum aus */
        //    QObject::dumpObjectTree();
}

void BioClient::closeConnection()
{
        if (pm != NULL)
                pm->closeConnection();
}


void BioClient::sendToServer()
{
        if (pm != NULL)
                pm->sendToServer();
        else
                displayDataBC("Keine Verbindung zum Server");

}

void BioClient::getUserRole()
{
        QString h_buf;
        h_buf.append(tr(authTextOne->text()));
        h_buf.append("::");
        h_buf.append(tr(authTextTwo->text()));
        emit sendUserRole(h_buf);
}

void BioClient::displayDataBC(QString string)
{
        infoText->append(tr(string));
        infoText->setCursorPosition(infoText->numLines(),0,0);
}

/** SLOT der getriggert wird, wenn man den Step-By-Step-Button drckt
		Es wird das SIGNAL zum schicken der Daten ber den Kontrollkanal gefeuert*/
void BioClient::sbsPressed()
{
        step->setText("Nchster Schritt");
        step->setPalette(QPalette(Qt::gray));
        step->setEnabled(FALSE);
        emit stepContinue();

}
/** SLOT um zu berprfen ob gecklickt wurde */
void BioClient::checkStep()
{

        if (this->SbSCheckBox->isChecked()) {
                step->setEnabled(TRUE);
                step->setText("Drcken");
                step->setPalette(QPalette(Qt::red));
        } else
                emit stepContinue();
}
