/***************************************************************************
                          bioclient.h  -  description
                             -------------------
    begin                : Mon Jan 21 12:38:33 CET 2002
    copyright            : (C) 2002 by Willem Froehling
    email                : willem@koram.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef BIOCLIENT_H
#define BIOCLIENT_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <kapp.h>
#include <qwidget.h>
#include <qapplication.h>
#include <qvbox.h>
#include <qhbox.h>
#include <qmultilineedit.h>
#include <qlineedit.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qcheckbox.h>
#include <qcheckbox.h>
#include <qregexp.h>
#include <qscrollbar.h>
#include <qgroupbox.h>

#include "protocolmanager.h"



/** BioClient ist die Basisklasse des Projektes*/
class BioClient : public QVBox
{
        Q_OBJECT
public:
        /** construtor */
        BioClient(const QString& host, Q_UINT16 port);
        /** destructor */
        ~BioClient();

        /*nNetzwerkklasse fr die Verbindungskontrolle */
        ProtocolManager* pm;

        QPushButton* step;

public slots:
        void displayDataBC(QString);
        void getUserRole();
        /** SLOT der getriggert wird, wenn man den Step-By-Step-Button drckt */
        void sbsPressed();
        /** SLOT um zu berprfen ob gecklickt wurde */
        void checkStep();


signals:
        void sendUserRole(QString);
        /** SIGNAL welches ausgelst wird, wenn der SbS-Knopf gedrckt wrde */
        void stepContinue();


private slots:
        void startConnection();
        void closeConnection();
        void sendToServer();

private:

        // Ausgabe Fenster
        QMultiLineEdit* infoText;

        // TextFelder fr Benutzername und Rolle
        QLineEdit* authTextOne;
        QLineEdit* authTextTwo;

        QCheckBox* SbSCheckBox;

        // Serveradresse und Port
        QString hostname;
        Q_UINT16 portnum;
};

#endif
