/***************************************************************************
                          dataprotocol.h  -  description
                             -------------------
    begin                : Wed Sep 18 2002
    copyright            : (C) 2002 by Willem Froehling
    email                : willem@koram.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DATAPROTOCOL_H
#define DATAPROTOCOL_H

#include <qsocketnotifier.h>
#include <qstring.h>
#include "ssl_common.h"
#include "fileloader.h"

/**Diese Klasse ist fr den Daten-Kanal auf Clientseite zustndig
  *@author Willem Froehling
  */

class DataProtocol : public QObject
{
        Q_OBJECT

public:
        DataProtocol(QString myID, QString hostname, Q_UINT16 port, SSL_Common* sslcom, SSL_CTX* ctx, QObject* parent);
        ~DataProtocol();
        /** Diese Methode sendet die Daten ber den TLS-Daten-Kanal */
        int sendData(QByteArray buf);
        /* Verbindung beenden */
        int closeConnection();

private:
        SSL_Common* dpsslcom;
        QSocketNotifier* sn;
        SSL_CTX* dp_ctx;
        SSL* ssl;
        BIO* sbio;
        FileLoader* image;
        QByteArray buffer;
        int sock;
        QString* dpID;

public slots:
        /* Wird vom ControlProtocol getriggert, wenn
        die Aufgezeichneten Daten ber den Daten-Kanal geschickt werden sollen */
        void triggerSendBioData(QString methoden);
signals:
        /** Nachdem die Daten ber den Datenkanal gesendet wurden, wird dieses Signal an das Kontrollprotokoll ausgelst */
        void bioDataSent(int tBytes);
};

#endif
