/***************************************************************************
                          networkprotocol.h  -  description
                             -------------------
    begin                : Sat Apr 13 2002
    copyright            : (C) 2002 by Willem Froehling
    email                : willem@koram.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef NETWORKPROTOCOL_H
#define NETWORKPROTOCOL_H

#include <qnetworkprotocol.h>

/**Abgeitete Klasse von QNetworkProtocol.
  *@author Willem Froehling
  */

class NetworkProtocol : public QNetworkProtocol
{
public:
        NetworkProtocol(QString& host, Q_UINT16 port);
        ~NetworkProtocol();

        // Einige dieser Methoden mssen reimplementiert werden
        //		void QNetworkProtocol::operationListChildren( QNetworkOperation *op );
        //    void QNetworkProtocol::operationMkDir( QNetworkOperation *op );
        //    void QNetworkProtocol::operationRemove( QNetworkOperation *op );
        //    void QNetworkProtocol::operationRename( QNetworkOperation *op );
        //    void QNetworkProtocol::operationGet( QNetworkOperation *op );
        //    void QNetworkProtocol::operationPut( QNetworkOperation *op );

        //But it's unlikely that the network protocol you implement supports all these operations. So, just reimplement the operations, which are supported by the protocol. Additionally you have to specify which operations are supported then. This is done by reimplementing
        //    int QNetworkProtocol::supportedOperations() const;

        //The last method you have to reimplement is
        //    bool QNetworkProtocol::checkConnection( QNetworkOperation *op );

        //Now if and error occurred and you need to handle it, do
        //
        //    if ( operationInProgress() ) {
        //        operationInProgress()->setErrorCode( error_code_of_your_error );
        //        operationInProgress()->setProtocolDetails( detail ); // optional!
        //        emit finished( operationInProgress() );
        //        return;
        //    }

        // That's all. The connection to the QUrlOperator and so on is done automatically.
        // Additionally, if the error was really bad so that no more operations can be done in the
        // current state (e.g. if the host couldn't be found), call, before emitting finished()
        // QNetworkProtocol::clearOperationStack().

};

#endif
