/***************************************************************************
                          protocolmanager.h  -  description
                             -------------------
    begin                : Mon Jul 1 2002
    copyright            : (C) 2002 by Willem Froehling
    email                : willem@koram.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PROTOCOLMANAGER_H
#define PROTOCOLMANAGER_H

#include <iostream.h>
#include <qobject.h>
#include <qtextstream.h>
#include <openssl/ssl.h>
#include "ssl_common.h"
#include "controlprotocol.h"
#include "dataprotocol.h"

#include <stdlib.h>
#include <time.h>

/**Diese Klasse kmmert sich um die Netzwerbindung
  *@author Willem Froehling
  */
class ProtocolManager : public QObject
{
        Q_OBJECT

public:
        ProtocolManager(const QString& host, Q_UINT16& port, QObject* parent);
        ~ProtocolManager();
        void startConnection();
        void closeConnection();
        void sendToServer();
        // OpenSSL
        SSL_CTX* ctx;
        int sock;

public slots:
        /** SLOT, wird vom ControlProtocol getriggert und erzeugt einen DatenKanal */
        void openDataChannel(QString dp_hostname, Q_UINT16 dp_port);
        /** Slot zum beenden des Veerbindung des Datenkanals */
        void closeDataChannel();
        /** Leitet gui_str einfach weiter an die GUI */
        void displayDataThrow(QString gui_str);

signals:
        void  displayDataPM(QString);

private:

        QString hostname, myID;
        Q_UINT16 portnum;

        // Server AuthMethod kodiert mit Q_UINT16
        Q_UINT16 serverMethodList;

        ControlProtocol* cp;
        DataProtocol* dp;

        SSL_Common* ssl_common;
        QObject* myparent;
};
#endif
