/***************************************************************************
                          bioserver.cpp  -  description
                             -------------------
    begin                : Mon Jan 21 12:38:33 CET 2002
    copyright            : (C) 2002 by Willem Froehling
    email                : willem@koram.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "bioserver.h"
#include <iostream.h>


BioServer::BioServer(QWidget* parent=0, const char *name=0)
{
        Q_UINT16 port = 4342;

        setSpacing(10);
        QString itext = QString(
                                "Authentikations Server\n"
                                "----------------------\n"
                                "W. Froehling 2003"
                        );
        QLabel *lb = new QLabel( itext, this );
        lb->setAlignment( AlignHCenter );

        infoText = new QMultiLineEdit( this );
        infoText->setReadOnly(TRUE);
        infoText->setMinimumSize(400,600);
        infoText->setFont(QFont("helvetica",10, QFont::Bold));
        infoText->append("Server: Bereit, warte auf Verbindungen...");

        QHBox *hbuttonBox = new QHBox(this);

        QVButtonGroup *vBGMethod = new QVButtonGroup("Methoden zur Auswahl: ",hbuttonBox);
        chooseCheckBox1 = new QCheckBox("Lampe oben-links", vBGMethod);
        chooseCheckBox2 = new QCheckBox("Lampe oben-rechts", vBGMethod);
        chooseCheckBox3 = new QCheckBox("Lampe unten-links", vBGMethod);
        chooseCheckBox4 = new QCheckBox("Lampe unten-rechts", vBGMethod);

        QVButtonGroup *vBGAuth = new QVButtonGroup("Authentikation :",hbuttonBox);
        authRadioButtonYes = new QRadioButton("Auth OK", vBGAuth);
        authRadioButtonNo = new QRadioButton("Auth BAD",vBGAuth);
        authRadioButtonNo->setChecked(TRUE);

        QPushButton *quit = new QPushButton("Quit", this);


        connect( quit, SIGNAL(clicked()), qApp, SLOT(quit()) );

        /* Neuen Protokoll-Manager erstellen */
        pm = new ProtocolManager("localhost", port, (QObject*)this);

        if (pm->ok()) {
                connect( pm, SIGNAL(displayData(int,QString)),this, SLOT(displayData(int,QString)) );
        } else {
                cout << "Fehler bei erstellung pm" << endl;
                exit(-1);
        }
}

BioServer::~BioServer()
{
        cout << "Destroying BioServer !!!!" << endl;
}

void BioServer::displayData(int clientID, QString clientdata)
{
        //    		QColorGroup *textColorGroup = new QColorGroup();
        //    		textColorGroup->setColor(QColorGroup::Text, QColor(clientID,clientID,clientID));
        //    		infoText->setPaperColorGroup(*textColorGroup);
        //
        //     QPalette pal = infoText->palette();
        //     pal.setColor( QColorGroup::Text, QColor(clientID, clientID, clientID));
        //     infoText->setPalette( pal);

        clientdata.insert(0,"|");
        clientdata.insert(0,(QString::number(clientID)));

        infoText->append(clientdata);
        // Autoscroll
        infoText->setCursorPosition(infoText->numLines(),0,0);
}

void BioServer::getCheckBoxStatus(QString clientID)
{
        QString meth_status;
        if (chooseCheckBox1->isChecked()) {
                meth_status.append("A");
        }
        if (chooseCheckBox2->isChecked()) {
                meth_status.append("B");
        }
        if (chooseCheckBox3->isChecked()) {
                meth_status.append("C");
        }
        if (chooseCheckBox4->isChecked()) {
                meth_status.append("D");
        }
        emit sendCheckBoxStatus(meth_status, clientID);
}

void BioServer::getAuthStatus(QString clientID)
{
        bool authStatus = FALSE;
        if (authRadioButtonYes->isChecked()) {
                authStatus=TRUE;
        } else {
                authStatus=FALSE;
        }
        emit sendAuthStatus(authStatus, clientID);
}
