/***************************************************************************
                          bioserver.h  -  description
                             -------------------
    begin                : Die Jan 22 20:43:44 CET 2002
    copyright            : (C) 2002 by Willem Froehling
    email                : willem@koram.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef BIOSERVER_H
#define BIOSERVER_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <qvbox.h>
#include <kapp.h>
#include <qwidget.h>
#include <qtextview.h>
#include <qmultilineedit.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qcheckbox.h>
#include <qvbuttongroup.h>
#include <qradiobutton.h>
#include <qpalette.h>
#include <qcolor.h>
#include <stdlib.h>
#include <qscrollview.h>

#include "protocolmanager.h"


/** BioServer ist die Basisklasse des Projektes */
class BioServer : public QVBox
{
        Q_OBJECT
public:
        /** construtor */
        BioServer(QWidget* parent=0, const char *name=0);
        /** destructor */
        ~BioServer();


public slots:
        void displayData(int clientID,QString clientdata);
        void getCheckBoxStatus(QString);
        void getAuthStatus(QString);

signals:
        void sendCheckBoxStatus(QString, QString);
        void sendAuthStatus(bool, QString);

private:

        QMultiLineEdit* infoText;
        QCheckBox *chooseCheckBox1;
        QCheckBox *chooseCheckBox2;
        QCheckBox *chooseCheckBox3;
        QCheckBox *chooseCheckBox4;
        QRadioButton *authRadioButtonYes;
        QRadioButton *authRadioButtonNo;

        ProtocolManager* pm;

};
#endif
