/***************************************************************************
                          dataprotocol.h  -  description
                             -------------------
    begin                : Wed Sep 18 2002
    copyright            : (C) 2002 by Willem Froehling
    email                : willem@koram.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DATAPROTOCOL_H
#define DATAPROTOCOL_H

#include <qserversocket.h>
#include <qsocketnotifier.h>
#include <qcstring.h>


#include  "ssl_common.h"
#include "image.h"

/**Diese Klasse kmmert sich um den Daten-Kommunikation-Kanal
  *@author Willem Froehling
  */

class DataProtocol : public QServerSocket
{

        Q_OBJECT

public:
        DataProtocol(SSL_Common* ssl_com_pm, SSL_CTX* ctx, int d_port);
        ~DataProtocol();
        void newConnection(int d_socket);

        // Wenn aus dem Netz SSL_close_notify empfangen wird, beendet diese Methode die Verbindung
        void closeConnection(int sock);

        int listenPort;

private:
        QSocketNotifier* sn;
        SSL_Common* ssl_com_dp;
        SSL* ssl_dp;
        SSL_CTX* myctx;
        int    myID;

        BIO *sbio;
        BIO *io,*ssl_bio;
        Image *authBild;

public slots:
        /** Dieser SLOT wird aufgerufen, wenn Daten aus dem Netzwerk auftauchen */
        void dataReceived();
        /** Wird vom Kontrollprotokoll ausgelst, wenn der Client alles bertragen hat */
        void check_bioData(int cp_BytesRecv, QString);
        /** Slot der ein neues Objekt DataChannel erzeugt und eine LISTEN Socket bindet */
        void dataChannelReq();
signals:
        /** Gibt das Ergebnis des Datenchecks an das Kontrollprotokoll zurck */
        void check_bioData_result(bool data_result, QString);
        /** Signal zum bertragen des Dataports */
        void dataChannelResult(int dPort);
        /** SIGNAL um Zeichen in der GUI darzustellen */
        void displayData(int,QString);
        /** SIGNAL zum Benachrichtigen, dass der Datenkanal abgebaut wurde. */
        void dp_connectionClosed();

};

#endif
