/***************************************************************************
                          image.cpp  -  description
                             -------------------
    begin                : Mon Dec 9 2002
    copyright            : (C) 2002 by Willem Froehling
    email                : willem@koram.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "image.h"
#include <iostream.h>
Image::Image()
{
        bufferSize = 0;
        bildBuffer = (char*) malloc(2);
        tmpBuffer = NULL;

        /* Bildspeicher initialisieren */
        strcpy(bildBuffer, "");

}

Image::~Image()
{
        //  cout << "Destroying Image !!!!" << endl;
}

void Image::appendData(char *data,int dSize)
{
        /* Hilfszeiger fr das Zusammenstellen der Bilderdaten */
        char *hBufferzeiger;

        /* Speicherplatz anfodern fr die schon empfangenen Daten und zustzlich noch den neuen Datenteil */
        tmpBuffer =(char *) malloc(bufferSize+dSize);

        if (tmpBuffer != NULL) {
                /* Den schon vorhanden Datensatz in den neuen Speicherbereich kopieren*/
                tmpBuffer = (char*) memcpy(tmpBuffer, bildBuffer, bufferSize);
                /* Alten Datensatz freigeben */
                free(bildBuffer);
                bildBuffer = NULL;
                /* hBufferzeiger zeigt im neuen Datenbereich auf den Platz hinter den schon empfangenen Daten */
                hBufferzeiger = tmpBuffer+bufferSize;
                /* Kopieren der neuen Daten hinter den schon empfangen Datensatz */
                (char*) memcpy(hBufferzeiger, data, dSize);
                /* bildBuffer zeigt nun auf den aktuellen Datensatz */
                bildBuffer = tmpBuffer;
                /* tmpBuffer wird nicht mehr bentigt, darf aber nicht frei gegeben werden, da er auf den aktuellen Datensatz zeigt */
                tmpBuffer = NULL;
                /* Gre des schon vorhanden Datensatzes berechnen */
                bufferSize += dSize;
        }
}
/** Gibt die Anzahl der Bytes, welche empfangen wurde zurck */
int Image::giveBytes()
{
        return (bufferSize);
}

/** Wenn alle Daten empfangen wurden, wird hierdurch veranlasst, dass Bild auf den Bildschirm zu zeichnen */
void Image::showImage()
{

        /* Empfangen Buffer als QByteArray wrappen*/
        baBuffer.setRawData( bildBuffer, bufferSize );

        /* Den eingerichteten QByteArray deserialisieren */
        QDataStream bufferStream(baBuffer, IO_ReadOnly);

        /* Die Daten im ByteArray in das Pixmap bertragen  */
        bufferStream >> bild;

        /* Empfangen Buffer wieder entwrappen */
        baBuffer.resetRawData( bildBuffer, bufferSize) ;

        /* Das Bild auf dem Bildschirm darstellen */
        QWidget* fenster = new QWidget();
        QLabel *label = new QLabel(fenster);
        label->resize(bild.width(),bild.height());
        fenster->resize(bild.width(),bild.height());
        label->setPixmap(bild);
        fenster->show();

        /* Nachdem das Bild dargestellt wurde, wird BufferSize wieder auf 0 gesetzt, fr weitere Bilder */
        bufferSize = 0;

}
