/***************************************************************************
                          protocolmanager.h  -  description
                             -------------------
    begin                : Tue Aug 20 2002
    copyright            : (C) 2002 by Willem Froehling
    email                : willem@koram.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PROTOCOLMANAGER_H
#define PROTOCOLMANAGER_H

#include <qobject.h>
#include "controlprotocol.h"
#include "dataprotocol.h"
#include "ssl_common.h"


#define KEYFILE "server.pem"
#define PASSWORD "password"
#define DHFILE "dh1024.pem"

/**bernimmt die Kontrolle der Netzverbindung
  *@author Willem Froehling
  */

class ProtocolManager : public QServerSocket
{
        Q_OBJECT
public:
        ProtocolManager(const QString& host, Q_UINT16& port, QObject* parent=0);
        ~ProtocolManager();

public slots:
        void newConnection(int socket);
        /** SLOT der einfach weiterreicht zu der GUI */
        void displayDataPassthrow(int cID, QString cString);
        /** Slot der getriggert wird, wenn die Netzverbindung beendet wird */
        void clientCut();
        /** SLOT der benutzt wird, wenn der Datenkanal eine Verbindung beendet */
        void dp_connectionClosed();

private:
        SSL* ssl_pm;
        SSL_Common* ssl_com_pm;
        SSL_CTX *ctx;
        ControlProtocol* cp;
        DataProtocol* dp;
        int cp_socket, clientId, dataport;
        char buffer[BUFSIZE];

        QString CPinBuffer;
        QObject* myparent;

signals: // Signals
        /** Signal zur Ausgabe in der GUI */
        void displayData(int,QString);

};

#endif
