/***************************************************************************
                          ssl_common.h  -  description
                             -------------------
    begin                : Tue Aug 20 2002
    copyright            : (C) 2002 by Willem Froehling
    email                : willem@koram.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SSL_COMMON_H
#define SSL_COMMON_H
extern "C"
{
#include <openssl/ssl.h>
#include <openssl/err.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <netdb.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include "c_ssl.h"

}
/**SSL funktionen
  *@author Willem Froehling
  */


#define CA_LIST "root.pem"
#define HOST    "localhost"
#define RANDOM  "random.pem"
#define PORT    4342
#define BUFSIZE 1024



class SSL_Common
{
public:
        SSL_Common(char* keyfile, char* password);
        ~SSL_Common();

        int err_exit(char* string);
        int berr_exit(char* string);
        static void sigpipe_handle(int x);
        SSL_CTX* initialize_ctx();
        void load_dh_params(SSL_CTX* ctx,char* file);
        void generate_eph_rsa_key(SSL_CTX* ctx);
        void destroy_ctx(SSL_CTX* ctx);

        // Variablen
        BIO* bio_err;
        char* keyfile;
};


#endif
